\ Do not use this file except in compliance with the License. You may
\ obtain a copy of the License at http://www.microcore.org/License/
\ Software distributed under the License is distributed on an "AS IS" basis,
\ WITHOUT WARRANTY OF ANY KIND, either express or implied.
\ See the License for the specific language governing rights and limitations
\ under the License.
\
\ The Original Code is: MicroCore CONFIG.F 1.20
\
\ The Initial Developer of the Original Code is Klaus.Schleisiek AT hamburg.de.
\ Port to the gforth system and extensions by Ulrich.E.Hoffmann AT xlerb.de 
\
\ Introduction  see: doc/uCore_Introduction.pdf
\ Tools         see: doc/uCore_Implementation.pdf
\ Versions      see: uCross_Versions.txt
\ License       see: doc/uCore_License.pdf
\ Conventions   see: doc/uCore_Conventions.pdf
\ Contributors  see: doc/uCore_Contributors.pdf
\
\ MicroCore Forth Cross-compiler configuration


\ Choose on of the following
 include win32for-config.f
\ include gforth-config.f


\ Some System word (re)definitions for a more sympathetic environment

: have ( <spaces>ccc<spaces> -- flag )  BL WORD FIND NIP ;

: shift  ( n1 quan -- n2 )  dup 0< IF  abs rshift  EXIT THEN  lshift ;

: ndrop  ( n1 .. nn n -- )   0 DO  drop  LOOP ;

: comp?  ( -- f )   State @ 0<> ;
: exec?  ( -- f )   State @ 0= ;

: ?pairs  ( n1 n2 -- )   - abort" unstructured!" ;      \ for checking conditional constructs

: :       ( -- 0 )   : 0 ;                             \ this allows to create an "intelligent" ; later on
                                                       \ for MACRO definitions to pick the proper
: ;       ( 0 -- )   0 ?pairs postpone ; [ 0 ?pairs ] ; immediate       \ ; behaviour

: Does> ( 0 -- 0 )  >r postpone Does> r> ; immediate

: :noname ( -- 0 ) :noname 0 ;

: 0=EXIT  ( f -- )   postpone 0= postpone ?EXIT ; immediate

: case?   ( n1 n2 -- n1 ff | tf )   over = dup IF  nip  THEN ;          \ the most primitive case operator

