\ Do not use this file except in compliance with the License. You may
\ obtain a copy of the License at http://www.microcore.org/License/
\ Software distributed under the License is distributed on an "AS IS" basis,
\ WITHOUT WARRANTY OF ANY KIND, either express or implied.
\ See the License for the specific language governing rights and limitations
\ under the License.
\
\ The Original Code is: MicroCore CONSTANTS.F 1.20
\
\ The Initial Developer of the Original Code is Klaus.Schleisiek AT hamburg.de.
\
\ Introduction  see: doc/uCore_Introduction.pdf
\ Tools         see: doc/uCore_Implementation.pdf
\ Versions      see: uCross_Versions.txt
\ License       see: doc/uCore_License.pdf
\ Conventions   see: doc/uCore_Conventions.pdf
\ Contributors  see: doc/uCore_Contributors.pdf
\
\ MicroCore hardware/software interface: Register Constants
\

Host WITH_LOCALS Target Version WITH_LOCALS  \ RSP-offset LOCAL addressing?
Host WITH_TASKS  Target Version WITH_TASKS   \ base-offset TASK addressing?
Host WITH_NOS    Target Version WITH_NOS     \ with NOS register?
Host WITH_TOR    Target Version WITH_TOR     \ with TOR register?
Host WITH_IP     Target Version WITH_IP      \ with IP register for threaded code interpretation?
Host WITH_TOKENS Target Version WITH_TOKENS  \ with token threaded code support?
Host VAN_NEUMANN Target Version VAN_NEUMANN  \ read/writeable program memory?

Host #data     Target Constant #data
Host #smallest Target Constant #smallest
                    8 Constant #rs_addr_width   \ : NATURAL :=  8; -- return stack pointer width
                    5 Constant #ds_addr_width   \ : NATURAL :=  5; -- data stack pointer width
                    3 Constant #tasks_addr_width

#tasks_addr_width 2** Constant #tasks
#rs_addr_width    2** Constant #rstack
#ds_addr_width    2** Constant #dstack

\ hard wired trap vectors
0 Constant #reset         \ reset vector
1 Constant #isr           \ interrupt service routine
2 Constant #esr           \ exception service routine
3 Constant #osr           \ overflow service routine
4 Constant #break         \ break point service routine
5 Constant #usr1
6 Constant #usr2
7 Constant #code          \ start of compiled code

\ I/O registers
-3 Constant DEBUG_REG

\ STATUS register
   1 Constant #c
   2 Constant #ovl
   4 Constant #ie
   8 Constant #iis
 $10 Constant #lit
 $20 Constant #neg
 $40 Constant #zero
$80 Constant #in
$100 Constant #out

