\ Do not use this file except in compliance with the License. You may
\ obtain a copy of the License at http://www.microcore.org/License/
\ Software distributed under the License is distributed on an "AS IS" basis,
\ WITHOUT WARRANTY OF ANY KIND, either express or implied.
\ See the License for the specific language governing rights and limitations
\ under the License.
\
\ The Original Code is: MicroCore CORETEST.F 1.20
\
\ The Initial Developer of the Original Code is Klaus.Schleisiek AT hamburg.de.
\
\ Introduction  see: doc/uCore_Introduction.pdf
\ Tools         see: doc/uCore_Implementation.pdf
\ Versions      see: uCross_Versions.txt
\ License       see: doc/uCore_License.pdf
\ Conventions   see: doc/uCore_Conventions.pdf
\ Contributors  see: doc/uCore_Contributors.pdf
\
\ MicroCore core test for VHDL-Version 1.20
\

-16 CONSTANT IOPORT1
-17 CONSTANT IOPORT2

Variable Location  1 allot

: zeroEXIT   ( n1 -- n2 )     dup  ?EXIT  0= ;
: zero-EXIT  ( n1 -- n2 )     dup 0=EXIT  0= ;
: signEXIT   ( n1 -- n2 )     neg  ?EXIT  0= ;
: sign-EXIT  ( n1 -- n2 )     neg 0=EXIT  0= ;
: carryEXIT  ( n1 -- n2 )   carry  ?EXIT  0= ;
: carry-EXIT ( n1 -- n2 )   carry 0=EXIT  0= ;
: ovl-EXIT   ( n1 -- n2 )     ovl 0=EXIT  0= ;

: test_branches  ( -- ) 
          0 neg IF  invert  THEN    IF  $1 dup IoPort1 ! BEGIN REPEAT THEN
         -1 neg IF  invert  THEN    IF  $2 dup IoPort1 ! BEGIN REPEAT THEN
    0 u2/ carry IF  invert  THEN    IF  $3 dup IoPort1 ! BEGIN REPEAT THEN
    1 u2/ carry IF  invert  THEN 0= IF  $4 dup IoPort1 ! BEGIN REPEAT THEN
        -1  zeroEXIT invert         IF  $5 dup IoPort1 ! BEGIN REPEAT THEN
         0  zeroEXIT invert         IF  $6 dup IoPort1 ! BEGIN REPEAT THEN
        -1 zero-EXIT                IF  $7 dup IoPort1 ! BEGIN REPEAT THEN
         0 zero-EXIT                IF  $8 dup IoPort1 ! BEGIN REPEAT THEN
        -1  signEXIT invert         IF  $9 dup IoPort1 ! BEGIN REPEAT THEN
         0  signEXIT invert         IF  $A dup IoPort1 ! BEGIN REPEAT THEN
         0 sign-EXIT                IF  $B dup IoPort1 ! BEGIN REPEAT THEN
        -1 sign-EXIT                IF  $C dup IoPort1 ! BEGIN REPEAT THEN
    1 u2/  carryEXIT                IF  $D dup IoPort1 ! BEGIN REPEAT THEN
    0 u2/  carryEXIT invert         IF  $E dup IoPort1 ! BEGIN REPEAT THEN
    0 u2/ carry-EXIT                IF  $F dup IoPort1 ! BEGIN REPEAT THEN
    1 u2/ carry-EXIT invert         IF $10 dup IoPort1 ! BEGIN REPEAT THEN
;

: test_unary ( -- )
   -1 2*                      cc carry IF  $12 dup IoPort1 ! BEGIN REPEAT THEN  ( -- )
   invert 1 =                       0= IF  $13 dup IoPort1 ! BEGIN REPEAT THEN  ( -- )
   -1 u2/                     cc carry IF  $14 dup IoPort1 ! BEGIN REPEAT THEN  ( $7FF )
   invert 2*                  cc carry IF  $15 dup IoPort1 ! BEGIN REPEAT THEN  (    0 )
   dup 0= invert                       IF  $16 dup IoPort1 ! BEGIN REPEAT THEN  (    0 )
   cc ror                        carry IF  $17 dup IoPort1 ! BEGIN REPEAT THEN  ( $800 )
   #smallest  -                        IF  $18 dup IoPort1 ! BEGIN REPEAT THEN  ( -- )
   #smallest rol              cc carry IF  $19 dup IoPort1 ! BEGIN REPEAT THEN  (    1 )
   rol                           carry IF  $1A dup IoPort1 ! BEGIN REPEAT THEN  ( -- )
   2 -                                 IF  $1B dup IoPort1 ! BEGIN REPEAT THEN  ( -- )
   0 0= invert  1 0= or                IF  $1C dup IoPort1 ! BEGIN REPEAT THEN  ( -- )
   #smallest 2/ #smallest dup u2/ or - IF  $1D dup IoPort1 ! BEGIN REPEAT THEN  ( -- )
   1 2/                       cc carry IF  $1E dup IoPort1 ! BEGIN REPEAT THEN  (    0 )
   0= invert                           IF  $1F dup IoPort1 ! BEGIN REPEAT THEN  ( -- )
;
\ SL     BOTH ALU Op: 2*       2*
\ ASR    BOTH ALU Op: 2/       2/
\ LSR    BOTH ALU Op: u2/      u2/
\ ROR    BOTH ALU Op: ror      don't
\ ROL    BOTH ALU Op: rol      don't
\ ZEQU   BOTH ALU Op: 0=       0=
\ CC     BOTH ALU Op: cc       don't

#smallest 1 +                      Constant #8001
#smallest                          Constant #8000
#smallest 1 - #smallest invert and Constant #7FFF
#smallest 2 - #smallest invert and Constant #7FFE

$55AA Constant ovl_pattern

#osr USR: osr   ( n -- ovl_pattern )  drop ovl_pattern ;

: test_arith  ( -- )
   3 4 +  ( 7 ) 4 -  ( 3 ) 4 2dup_+  ( 3 4 7 )
WITH_TOR [IF]  over swap -  [ELSE]  over_swap_-  [THEN]  ( 3 4 -3 )
   dup 0< and  ( 3 4 -3 )  negate  ( 3 4 3 )
   or  ( 3 7 ) xor  ( 4 ) 4 and  ( 4 ) 
   0 -1 0 d+  ( 3 1 )   3 1 d-           or  IF  $20 dup IoPort1 ! BEGIN REPEAT THEN
WITH_TOR [IF]
      -1     1 um*         >r    -1 - r> or  IF  $21 dup IoPort1 ! BEGIN REPEAT THEN  -- 0000 FFFF
       1    -1 um*         >r    -1 - r> or  IF  $22 dup IoPort1 ! BEGIN REPEAT THEN  -- 0000 FFFF
      -1    -1 um*    -2 - >r     1 - r> or  IF  $23 dup IoPort1 ! BEGIN REPEAT THEN  -- FFFE 0001
      -2    -1 um*    -3 - >r     2 - r> or  IF  $24 dup IoPort1 ! BEGIN REPEAT THEN  -- FFFD 0002
      -1    -2 um*    -3 - >r     2 - r> or  IF  $25 dup IoPort1 ! BEGIN REPEAT THEN  -- FFFD 0002
      -1 #7FFF um* #7FFE - >r #8001 - r> or  IF  $26 dup IoPort1 ! BEGIN REPEAT THEN  -- 7FFE 8001
   #7FFF    -1 um* #7FFE - >r #8001 - r> or  IF  $27 dup IoPort1 ! BEGIN REPEAT THEN  -- 7FFE 8001
       4     5 um* + 20 -                    IF  $28 dup IoPort1 ! BEGIN REPEAT THEN
      21 0     5 um/mod 4 - >r     1 - r> or IF  $29 dup IoPort1 ! BEGIN REPEAT THEN
      -3 1    -1 um/mod 1 - >r    -2 - r> or IF  $2A dup IoPort1 ! BEGIN REPEAT THEN
      -2 1    -1 um/mod 2 - >r     0 - r> or IF  $2B dup IoPort1 ! BEGIN REPEAT THEN
      -3 1    -2 um/mod 2 - >r     1 - r> or IF  $2C dup IoPort1 ! BEGIN REPEAT THEN
      -1 0 #8000 um/mod 1 - >r #7FFF - r> or IF  $2D dup IoPort1 ! BEGIN REPEAT THEN
       0 1     1 um/mod or status@ #ovl and #ovl xor or IF  $2E dup IoPort1 ! BEGIN REPEAT THEN
[THEN]  \ overflow tests
   #smallest dup + ?ovl ovl_pattern -                           IF  $D0 dup IoPort1 ! BEGIN REPEAT THEN
   0 0 + ?ovl ovl_pattern =                                     IF  $D1 dup IoPort1 ! BEGIN REPEAT THEN
       0     0 + ovl IF  drop ovl_pattern  THEN                 IF  $D2 dup IoPort1 ! BEGIN REPEAT THEN
   #7FFF #7FFF - ovl IF  drop ovl_pattern  THEN                 IF  $D3 dup IoPort1 ! BEGIN REPEAT THEN
   #8000 #8000 - ovl IF  drop ovl_pattern  THEN                 IF  $D4 dup IoPort1 ! BEGIN REPEAT THEN
   #8000     1 + ovl IF  drop ovl_pattern  THEN  #8001 -        IF  $D5 dup IoPort1 ! BEGIN REPEAT THEN
       1 #8000 + ovl IF  drop ovl_pattern  THEN  #8001 -        IF  $D6 dup IoPort1 ! BEGIN REPEAT THEN
   #8000     1 - ovl IF  drop ovl_pattern  THEN  ovl_pattern -  IF  $D7 dup IoPort1 ! BEGIN REPEAT THEN
       1 #8000 - ovl IF  drop ovl_pattern  THEN  ovl_pattern -  IF  $D8 dup IoPort1 ! BEGIN REPEAT THEN
   #8000 #7FFF + ovl IF  drop ovl_pattern  THEN  1+             IF  $D9 dup IoPort1 ! BEGIN REPEAT THEN
   #7FFF #8000 + ovl IF  drop ovl_pattern  THEN  1+             IF  $DA dup IoPort1 ! BEGIN REPEAT THEN
   #8000    -1 + ovl IF  drop ovl_pattern  THEN  ovl_pattern -  IF  $DB dup IoPort1 ! BEGIN REPEAT THEN
      -1 #8000 + ovl IF  drop ovl_pattern  THEN  ovl_pattern -  IF  $DC dup IoPort1 ! BEGIN REPEAT THEN
   #8000 #8000 + ovl IF  drop ovl_pattern  THEN  ovl_pattern -  IF  $DD dup IoPort1 ! BEGIN REPEAT THEN
;
: test_memory  ( -- )
   1 2   Location  
   st 1 +st  -1 +ld  1 +ld drop  
   2* - 0=EXIT $30 dup IoPort1 ! BEGIN REPEAT
;
: modify  ( n -- /n )  0= ;

: absbranch  ( n -- )   ;

: test_?call  ( -- )
          0 dup ?CALL modify    IF  $41 dup IoPort1 ! BEGIN REPEAT THEN
          1 dup ?CALL modify    IF  $42 dup IoPort1 ! BEGIN REPEAT THEN
         0 dup 0=CALL modify 0= IF  $43 dup IoPort1 ! BEGIN REPEAT THEN
         1 dup 0=CALL modify 0= IF  $44 dup IoPort1 ! BEGIN REPEAT THEN
   0 u2/ carry  ?CALL modify    IF  $45 dup IoPort1 ! BEGIN REPEAT THEN
   1 u2/ carry  ?CALL modify 0= IF  $46 dup IoPort1 ! BEGIN REPEAT THEN
   0 u2/ carry 0=CALL modify 0= IF  $47 dup IoPort1 ! BEGIN REPEAT THEN
   1 u2/ carry 0=CALL modify    IF  $48 dup IoPort1 ! BEGIN REPEAT THEN
        -1 neg  ?CALL modify    IF  $49 dup IoPort1 ! BEGIN REPEAT THEN
         0 neg  ?CALL modify    IF  $4A dup IoPort1 ! BEGIN REPEAT THEN
        -1 neg 0=CALL modify 0= IF  $4B dup IoPort1 ! BEGIN REPEAT THEN
         0 neg 0=CALL modify 0= IF  $4C dup IoPort1 ! BEGIN REPEAT THEN
  -1 ['] modify    nop CALL     IF  $4D dup IoPort1 ! BEGIN REPEAT THEN
     ['] absbranch nop BRANCH       $4E dup IoPort1 ! BEGIN REPEAT
;
: test_stack ( -- )
   $55 dup +   $55 2* -                   IF  $50 dup IoPort1 ! BEGIN REPEAT THEN
   1 2 swap 1 - >r 2 - r> or              IF  $51 dup IoPort1 ! BEGIN REPEAT THEN
   1 2 over 1 - >r 2 - >r 1 - r> or r> or IF  $52 dup IoPort1 ! BEGIN REPEAT THEN
   1 2 3 drop 2 - swap 1 - or             IF  $53 dup IoPort1 ! BEGIN REPEAT THEN
   1 2 5 nip + 6 -                        IF  $54 dup IoPort1 ! BEGIN REPEAT THEN
   55 0 nop ?dup +   55 -                 
   55 0     ?dup +   55 - or              IF  $55 dup IoPort1 ! BEGIN REPEAT THEN
   55 1     ?dup + + 57 -                     
   55 1 nop ?dup + + 57 - or              IF  $56 dup IoPort1 ! BEGIN REPEAT THEN
   0 >r r@  -1 r!  r> 1+ +                IF  $57 dup IoPort1 ! BEGIN REPEAT THEN
\   test_stack_depths - not implemented
;
: test_register ( -- )
   1 >r r@ r@ + 2 -                           IF  $60 dup IoPort1 ! BEGIN REPEAT THEN
   $55 r> + $56 -  r@ 1 = or                  IF  $61 dup IoPort1 ! BEGIN REPEAT THEN
   status@  0 status! status@ $3F and         IF  $62 dup IoPort1 ! BEGIN REPEAT THEN
   dup status!  status@ - #zero -             IF  $63 dup IoPort1 ! BEGIN REPEAT THEN
   1 2 3 dup dup dsp@ 1- dsp! drop drop + 3 - IF  $64 dup IoPort1 ! BEGIN REPEAT THEN
   1 >r 2 >r 3 >r rsp@ 1+ rsp! rdrop r> 1-    IF  $65 dup IoPort1 ! BEGIN REPEAT THEN
;
: test_iobus  ( -- )
   $99 ioport1 !   $71 ioport2 !
   ioport1 @ $99 = INVERT  ioport2 @ $99 =  OR IF  $70 dup IoPort1 ! BEGIN REPEAT THEN
;
: test_local  ( -- )
WITH_LOCALS [NOTIF]  EXIT  [THEN]
   r@ dup >r   1 l@ -                          IF  $80 dup IoPort1 ! BEGIN REPEAT THEN
   r@   -1 1 l!  r> r@ swap >r
      over 1 l!  1 l@ swap 1+ - -  rdrop       IF  $81 dup IoPort1 ! BEGIN REPEAT THEN
        5 -80 +lst  @  5 -                     IF  $82 dup IoPort1 ! BEGIN REPEAT THEN
;
: rsp_task  ( -- u )  rsp@ #rs_addr_width 1- FOR u2/ NEXT #tasks 1- and
;
: dsp_task  ( -- u )  dsp@ #ds_addr_width 1- FOR u2/ NEXT #tasks 1- and
;
: rsp_reg   ( -- u )  rsp@ 1+ #rstack 1- and
;
: dsp_reg   ( -- u )  dsp@ #dstack 1- and
;
: rsp_task! ( u -- )  r@ swap #rs_addr_width 1- FOR 2* NEXT rsp_reg or rsp! r!
;
: dsp_task! ( u -- )  #ds_addr_width 1- FOR 2* NEXT dsp_reg or dsp! drop
;
: test_tasks  ( -- )
WITH_TASKS [NOTIF]  EXIT  [THEN]
   task@   $100 task!
   task@ $100 - +                        IF  $90 dup IoPort1 ! BEGIN REPEAT THEN
   6 4 +tst @ 6 -                        IF  $90 dup IoPort1 ! BEGIN REPEAT THEN
   -6 4 t!  4 t@ -6 -                    IF  $91 dup IoPort1 ! BEGIN REPEAT THEN
   rsp_task 3 -                          IF  $92 dup IoPort1 ! BEGIN REPEAT THEN
   dsp_task 2 -                          IF  $93 dup IoPort1 ! BEGIN REPEAT THEN
   0 >r 7 rsp_task! 1 r!  3 rsp_task! r> IF  $94 dup IoPort1 ! BEGIN REPEAT THEN
;
: test_van_neumann ( -- )
VAN_NEUMANN [NOTIF]  EXIT  [THEN]
   $10 #smallest or ld  over >r
   $11 swap         st
   nop              ld
   rot swap         st
   @ r> - IF  $A0 dup IoPort1 ! BEGIN REPEAT THEN
   $11 -  IF  $A1 dup IoPort1 ! BEGIN REPEAT THEN
;

#usr1 USR: push_$10  ( -- n )       $10 ;
#usr2 USR: 4*        ( n1 -- n2 )   2* 2* ;

: test_user  ( -- )
   push_$10 $10 - IF  $B0 dup IoPort1 ! BEGIN REPEAT THEN
   $10 push_$10 - IF  $B1 dup IoPort1 ! BEGIN REPEAT THEN
   1 4*       4 - IF  $B2 dup IoPort1 ! BEGIN REPEAT THEN
   2 4*       8 - IF  $B3 dup IoPort1 ! BEGIN REPEAT THEN
;

Code exit,   ( -- )              r> ip!    end-code
Code var,    ( -- addr )     ip@ r> ip!    end-code
Code branch, ( -- )          ip@ ld + ip!  end-code
Code @,      ( addr -- n )   @             end-code
Code uCore,  ( -- )          EXIT          end-code
: IP-interpret  ( addr -- )  ip! ip-branch ;

WITH_TOKENS [IF]

$10 data-origin

: fill_token_table  ( -- )   exit, , var, , branch, , @, , uCore, , ;

$10 Constant [exit]
$11 Constant [var]
$12 Constant [branch]
$13 Constant [@]
$14 Constant [uCore]

$100 data-origin

: setup  ( -- start-ip )  fill_token_table
   here [var] , [ here swap ] 0 , here swap , [@] , [exit] , here swap , [uCore] ,
;
                       Constant IPVar
[ELSE]

$100 data-origin

: setup  ( -- start-ip )
   here var,  , [ here swap ] 0 , here swap ,  @, ,  exit, , here swap ,  uCore, ,
;
                       Constant IPVar
[THEN]

: test_IP  ( -- )
WITH_IP [NOTIF]  EXIT  [THEN]
   setup >r
     0 IPVar !  r@ IP-interpret
   $55 IPVar !  r@ IP-interpret $55 - + IF  $C0 dup IoPort1 ! BEGIN REPEAT THEN
   rdrop
;

0 [IF]

: test
   0 BEGIN REPEAT
;

[ELSE]

: test  ( -- )   
   1 2 3 0  ei     
   test_van_neumann  2 Ioport1 ! 
 
   rsp_task            Ioport1 !
   dsp_task            Ioport1 !   3 rsp_task! dup dup 2 dsp_task!
   test_register     4 Ioport1 !
   test_stack        5 Ioport1 !
   test_?call        6 Ioport1 !
   test_branches     7 Ioport1 !
   test_unary        8 Ioport1 !
   test_arith        9 Ioport1 !
   test_memory      10 Ioport1 !
   test_iobus       11 Ioport1 !
   test_local       12 Ioport1 !
   test_tasks       13 Ioport1 !
   test_IP          14 Ioport1 !
   test_user        15 Ioport1 !   0 dsp_task! drop drop

   3 FOR 1+ NEXT  
   0 ?FOR 1- NEXT
   4 ?FOR 1- NEXT
   + - + IF  $F0 dup IoPort1 ! BEGIN REPEAT THEN
   0 dup ioport1 ! BEGIN REPEAT      \ everything is ok if there is a zero in IoPort1 and a zero on the data stack
;
[THEN]

